// AIWriter.cpp: implementation of the CAIWriter class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Vectal4.h"
#include "AIWriter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////

void CAIWriter::WriteString( LPCTSTR str )  {
    m_file.Write( str, _tcslen( str ) );
}
void CAIWriter::WriteString( const CString &str )  {
    WriteString( (LPCTSTR)str );
}
void CAIWriter::WriteString( UINT nID )  {   
    CString str( (LPCSTR)nID );
    WriteString( str );
}


//////////////////////////////////////////////////////////////////////


void CAIWriter::WriteHead()
{
    WriteString( IDS_AI_HEAD );

    WriteString( IDS_AI_CREATIONDATE );

    CString    str;
    SYSTEMTIME st;

    GetSystemTime( &st );
    str.Format( "%d:%d %d.%d.%d", st.wHour, st.wMinute, st.wDay, st.wMonth, st.wYear );
    WriteString( str );
}

void CAIWriter::WriteBoxes( float x1, float y1, float x2, float y2 )
{
    CString    str;    
    //
    str.Format( "%d %d %d %d", (int)x1,(int)y1, (int)x2,(int)y2 );
    WriteString( IDS_AI_BBOX );
    WriteString( str );
    //
    str.Format( "%.4f %.4f %.4f %.4f", x1,y1, x2,y2 );
    WriteString( IDS_AI_HIRESBBOX );
    WriteString( str );

    // End Comments
    WriteString( IDS_AI_ENDCOMMENTS );

}

void CAIWriter::WritePoinf( float x, float y, BYTE bMode )
{
    CString str;    
    str.Format( "\r\n%.4f %.4f ", x,y );
    WriteString( str );
    WriteString( 1==bMode ? "m" : "L" );
}
