// FileExportDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Vectal4.h"
#include "FileExportDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



static CFileExportDlg* g_pFileExportDlg;
BOOL CALLBACK SettingsProc( HWND, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
    return g_pFileExportDlg->SettingsProc( uMsg, wParam,lParam );
}


/////////////////////////////////////////////////////////////////////////////
// CFileExportDlg

IMPLEMENT_DYNAMIC(CFileExportDlg, CFileDialog)

CFileExportDlg::CFileExportDlg(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
		DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd) :
		CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd)
{
    m_pExportSettings = NULL;
}


BEGIN_MESSAGE_MAP(CFileExportDlg, CFileDialog)
	//{{AFX_MSG_MAP(CFileExportDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CFileExportDlg::OnInitDialog() 
{
	CFileDialog::OnInitDialog();
	// 

    CWnd* pWnd = GetParent();

    RECT rt;
    pWnd->GetWindowRect( &rt );
    rt.right  -= rt.left;
    rt.bottom -= rt.top;

    pWnd->SetWindowPos( NULL, 0,0, rt.right, rt.bottom+40, SWP_NOMOVE );
    
    
    m_dlgSettings.Create( IDD_FILEEXPORT, pWnd );
    m_dlgSettings.SetWindowPos( NULL, 0, rt.bottom-54, 0,0, SWP_NOSIZE );

    g_pFileExportDlg = this;
    SetWindowLong( m_dlgSettings.m_hWnd, DWL_DLGPROC, (LONG)&::SettingsProc );


    // Det Settings
    m_dRatio = 0;
    if( m_pExportSettings )
    {
        //
        m_dlgSettings.SetDlgItemInt( IDC_EDIT_EXPORT_WIDTH,      m_pExportSettings->nWidth );
        m_dlgSettings.SetDlgItemInt( IDC_EDIT_EXPORT_HEIGHT,     m_pExportSettings->nHeigth );
        m_dlgSettings.SetDlgItemInt( IDC_EDIT_EXPORT_ITERATIONS, m_pExportSettings->nIterations );
        if( m_pExportSettings->nHeigth )
            m_dRatio = (double)m_pExportSettings->nWidth / m_pExportSettings->nHeigth;

        int nLines = pow( m_pExportSettings->nKneesN, m_pExportSettings->nIterations );
        m_dlgSettings.SetDlgItemInt( IDC_STATIC_EXPORT_LINES, nLines );
    }

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CFileExportDlg::OnTypeChange()
{
    BOOL bEnable  =  1 == m_ofn.nFilterIndex;

    m_dlgSettings.GetDlgItem( IDC_EDIT_EXPORT_WIDTH  )->EnableWindow( bEnable );
    m_dlgSettings.GetDlgItem( IDC_EDIT_EXPORT_HEIGHT )->EnableWindow( bEnable );
}


BOOL CFileExportDlg::SettingsProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
    if( WM_COMMAND == uMsg )
    {
        switch( HIWORD(wParam) )
        {
            case EN_KILLFOCUS:

                switch( LOWORD(wParam) )
                {
                    case IDC_EDIT_EXPORT_WIDTH:
                        m_pExportSettings->nWidth = m_dlgSettings.GetDlgItemInt( IDC_EDIT_EXPORT_WIDTH );
                        if( m_dRatio )  {
                            m_pExportSettings->nHeigth = int( m_pExportSettings->nWidth / m_dRatio + 0.6 );
                            m_dlgSettings.SetDlgItemInt( IDC_EDIT_EXPORT_HEIGHT, m_pExportSettings->nHeigth );
                        }
                        break;

                    case IDC_EDIT_EXPORT_HEIGHT:
                        m_pExportSettings->nHeigth = m_dlgSettings.GetDlgItemInt( IDC_EDIT_EXPORT_HEIGHT );
                        if( m_dRatio )  {
                            m_pExportSettings->nWidth = int( m_pExportSettings->nHeigth * m_dRatio + 0.6 );
                            m_dlgSettings.SetDlgItemInt( IDC_EDIT_EXPORT_WIDTH, m_pExportSettings->nWidth );
                        }
                        break;
                
                    case IDC_EDIT_EXPORT_ITERATIONS:
                        m_pExportSettings->nIterations = m_dlgSettings.GetDlgItemInt( IDC_EDIT_EXPORT_ITERATIONS );
                        int nLines = pow( m_pExportSettings->nKneesN, m_pExportSettings->nIterations );
                        m_dlgSettings.SetDlgItemInt( IDC_STATIC_EXPORT_LINES, nLines );
                        break;                        
                }
                break;
        }

    }


    return 0;
}
