// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Vectal4.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_ITERATIONSBAR, OnViewIterationsBar)
	ON_COMMAND(ID_VIEW_FULLSCREEN, OnViewFullscreen)
	ON_WM_MENUSELECT()
	//}}AFX_MSG_MAP
    ON_MESSAGE( WM_SETMESSAGESTRING, OnSetStatusString )
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
    ID_SEPARATOR
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bFullScreen = 0;

    m_nCustomIdleMessage = 0;

}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndIterationsBar.Create(this, IDR_MAINFRAME, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// fail to create
	}
    m_wndIterationsBar.SetOwner( this );   // For Resending  IterationsBar->FrameWnd->View  Scroll Messages

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndIterationsBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);


	return 0;
}

BOOL CMainFrame::PreCreateWindow( CREATESTRUCT& cs )
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

    m_nDefaulStyle = cs.style;  // Save DefaulStyle for FullScreen Toggling

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCommand(WPARAM wParam, LPARAM lParam) 
{
    // Let the View first Get the command.
    // We need EN_CHANGE from IterationsBar
    CView* pView = GetActiveView();
    if( pView )
    {   // If View processed the command (MESSAGE_MAP...)
        // SendMessage returns TRUE
        if ( pView->SendMessage( WM_COMMAND, wParam,lParam ) )
		    return TRUE;
    }
	
	return CFrameWnd::OnCommand(wParam, lParam);
}



void CMainFrame::OnViewIterationsBar() 
{
	CControlBar* pDialogBar = GetControlBar( AFX_IDW_DIALOGBAR );
	if( pDialogBar )
    {
        BOOL bShow  =  0 == ( WS_VISIBLE & pDialogBar->GetStyle() );

        ShowControlBar( pDialogBar, bShow, FALSE );
        GetMenu()->CheckMenuItem( ID_VIEW_ITERATIONSBAR, bShow ? MF_CHECKED : MF_UNCHECKED );
    }
}


void CMainFrame::OnViewFullscreen() 
{
    m_bFullScreen ^= 1;

    if( m_bFullScreen )
    {
        SetWindowLong( m_hWnd, GWL_STYLE, WS_POPUP );
        SetWindowPos ( 0, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED );
        ShowWindow( SW_MAXIMIZE );
    }
    else
    {
        ShowWindow( SW_RESTORE );
        SetWindowLong( m_hWnd, GWL_STYLE, m_nDefaulStyle );
        SetWindowPos ( 0, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER | SWP_FRAMECHANGED | SWP_SHOWWINDOW );
    }
	
    GetMenu()->CheckMenuItem( ID_VIEW_FULLSCREEN, m_bFullScreen ? MF_CHECKED : MF_UNCHECKED );
    GetToolBar()->GetToolBarCtrl().CheckButton( ID_VIEW_FULLSCREEN, m_bFullScreen );

}

// from here: http://www.vckbase.com/english/code/statusbar/ready_prompt.shtml.htm
//
// Show Custom Idle message in case m_nCustomIdleMessage
LRESULT CMainFrame::OnSetStatusString( WPARAM wParam, LPARAM lParam )
{
	UINT nIDLast = m_nIDLastMessage;
	m_nFlags &= ~WF_NOPOPMSG;

	CWnd* pMessageBar = GetMessageBar();
	if( pMessageBar )
	{
		CString sMsg;

		// set the message bar text
		if( lParam )
            sMsg = (LPCTSTR)lParam;     // User Sets String

		else if( wParam )
		{
			// map SC_CLOSE to PREVIEW_CLOSE when in print preview mode
			if( AFX_IDS_SCCLOSE == wParam  &&  m_lpfnCloseProc )
				wParam = AFX_IDS_PREVIEW_CLOSE;

			// get message associated with the ID indicated by wParam
            if( AFX_IDS_IDLEMESSAGE == wParam  &&  m_nCustomIdleMessage )  {
                sMsg.LoadString( m_nCustomIdleMessage );
                m_nCustomIdleMessage = 0;
            }
            else
	            GetMessageString( wParam, sMsg );
		}

		pMessageBar->SetWindowText( sMsg );

		// update owner of the bar in terms of last message selected
		CFrameWnd* pFrameWnd = pMessageBar->GetParentFrame();
		if( pFrameWnd )  {
			m_nIDLastMessage = (UINT)wParam;
			m_nIDTracking    = (UINT)wParam;
		}
	}

	m_nIDLastMessage = (UINT)wParam;    	// new ID (or 0)
	m_nIDTracking    = (UINT)wParam;       	// so F1 on toolbar buttons work

	return nIDLast;
}


// Customize Idle Status String:
// Do not show "Ready" Message if "File Export" is selected: Export takes time
void CMainFrame::OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu) 
{
	CFrameWnd::OnMenuSelect(nItemID, nFlags, hSysMenu);

    m_nCustomIdleMessage = ID_FILE_EXPORT==nItemID ? ID_FILE_EXPORT_SEL : 0;
/*
    switch( nItemID )
    {
        case ID_FILE_EXPORT:  m_nCustomIdleMessage = ID_FILE_EXPORT_SEL;  break;
        default:              m_nCustomIdleMessage = 0;                   break;
    }
*/
	
}
