// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__4D25F6B6_9A99_4C49_867F_A07D4214B7D1__INCLUDED_)
#define      AFX_MAINFRM_H__4D25F6B6_9A99_4C49_867F_A07D4214B7D1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "IterationsBar.h"
#include <afxpriv.h>                // For WM_SETMESSAGESTRING


class CMainFrame : public CFrameWnd
{
    BYTE    m_bFullScreen;          // FullScreen Mode
    LONG    m_nDefaulStyle;         // Save DefaulStyle for FullScreen Toggling

    UINT    m_nCustomIdleMessage;   // ID of Custom Idle Message on the StatusBar if any
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
    CIterationsBar* GetIterationsBar()  {  return &m_wndIterationsBar; }
    CStatusBar*     GetStatusBar()      {  return &m_wndStatusBar; }
    CToolBar*       GetToolBar()        {  return &m_wndToolBar; }

    void SetCustomIdleMessage( UINT n )  {  m_nCustomIdleMessage = n; }

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CIterationsBar  m_wndIterationsBar;
	CStatusBar      m_wndStatusBar;
	CToolBar        m_wndToolBar;
	CReBar          m_wndReBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnViewIterationsBar();
	afx_msg void OnViewFullscreen();
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	//}}AFX_MSG
    afx_msg LRESULT OnSetStatusString( WPARAM wParam, LPARAM lParam );
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__4D25F6B6_9A99_4C49_867F_A07D4214B7D1__INCLUDED_)
