// Mouser.h: interface for the CMouser class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MOUSER_H__808E578C_7B69_4CD9_8594_FB8A1CDB3381__INCLUDED_)
#define      AFX_MOUSER_H__808E578C_7B69_4CD9_8594_FB8A1CDB3381__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "Pattern.h"
#include "Spacer.h"
#include "CoordinateDlg.h"

//////////////////////////////////////////////////////////////////////

#define     MK_BUTTONDOWN       0x0100              // For WM_xBUTTONDOWN
#define     MK_DBLCLK           0x0200              // For WM_xBUTTONDOWN
#define     MK_BUTTON       ( MK_LBUTTON | MK_RBUTTON | MK_MBUTTON )
//#define     MK_KEY        ( MK_CONTROL | MK_SHIFT )


#define     ME_PROCESSED    1
#define     ME_REDRAW       2
//#define     ME_KNEEN        4
//#define     ME_POSITION     4


class CMouser : protected CSpacer
{
    CWnd*       m_pWndParent;

    CPoinf      m_pfCursor;
    CPoint      m_ptCursor;

    BYTE        m_bMode;
    int         m_nElem;

    // Popup Menus
    CMenu       m_menu;


    CCoordinateDlg      m_dlgCoordinate;


protected:

    void        SetParent( CWnd* pWnd )             {  m_pWndParent = pWnd; }

    void        SetCursorPoint( const CPoint& pt )  {  m_ptCursor = pt; }   // Save for Spacer::MoveOrigin
    void        SetCursorPoinf( const CPoint& pt )  {  m_pfCursor = CSpacer::ToPoinf( pt ); }
    void        TraceCursor   ( CPattern* );

    void        GetCursorStatus( TCHAR* str )  { _stprintf( str, "%.3f  %.3f", m_pfCursor.x, m_pfCursor.y ); }


    // Mouse Event Processors
	DWORD       OnMouseViewEvent( UINT message, WPARAM );
	DWORD       OnMouseDocEvent ( UINT message, WPARAM, CPattern* );


    // Arrow
    BYTE        m_bCtrl;
    UINT        m_nHitTest;             // Save HitTest for Required Arrow Restoring with WM_KEYUP

    BYTE        m_bPopupMenuLoop;

    HCURSOR     m_hArrows[5];
    BYTE        m_bArrow;
    void        DetArrow();


public:
	CMouser();
	virtual ~CMouser();

};

//////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_MOUSER_H__808E578C_7B69_4CD9_8594_FB8A1CDB3381__INCLUDED_)
