// Pattern.h: interface for the CPattern class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PATTERN_H__7244D613_8866_4E9D_896C_752FBC52FAB9__INCLUDED_)
#define      AFX_PATTERN_H__7244D613_8866_4E9D_896C_752FBC52FAB9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////

#include "Poinf.h"


#define MAXKNEES 32 

// Dirs Flags for BYTE m_bDirs
#define DIR_REVERSE 1
#define DIR_MIRROR  2
#define DIR_HIDE    4
#define DIR_STATIC  8


// Cursor Modes for DetCursorMode( .., BYTE& bMode )
#define MODEADD      0
#define MODESELPOINT 1
#define MODESELKNEE  2



class CPattern
{
    
protected:
    
    // Main Data of Pattern
    CPoinf  m_pfPoinfs[MAXKNEES+1];
    BYTE    m_bDirs   [MAXKNEES  ];
    int     m_nKneesN;

    // Temporary data - knees centres - for cursor icon changing with mouse moving
    CPoinf  m_pfKneesC[MAXKNEES];
    void    DetKneesC();


public:

    void    InitDefaultNew();   // Init Default New Data - Simple Dragon


    // Attributes
    CPoinf* GetPoinfs()  {  return m_pfPoinfs; }
    BYTE*   GetDirs()    {  return m_bDirs;    }
    int     GetKneesN()  {  return m_nKneesN;  }


    int     DetCursorMode( const CPoinf&, float fScale, BYTE& bMode );
    void    MovePoint( int n, const CPoinf& );
    int     AddPoint( int n, const CPoinf& pf );
    int     RemovePoint( int n );

    void    ChangeDir( int n, BYTE bBit );
    BYTE    GetDir( int n )  {  return m_bDirs[n]; }

    void    SetDefaultView( const CPoinf& f0, float sc, const CPoinf& f1 );


    void    Serialize( CArchive& );
};





//////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_PATTERN_H__7244D613_8866_4E9D_896C_752FBC52FAB9__INCLUDED_)
