// Poinf.h: interface for the CPoinf class.
// 
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POINF_H__21C2BCBF_50B3_450F_9F40_514E7AA0BC7F__INCLUDED_)
#define      AFX_POINF_H__21C2BCBF_50B3_450F_9F40_514E7AA0BC7F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////

#include <math.h>



// Geometry of 2D Point with FLOAT coordinates

struct CPoinf
{
    union {
        struct { float x,y;};   // Coordinates
        struct { float r,a;};   // Polar coordinates for fractal building
    };


public:
	CPoinf() {}
    CPoinf( float X, float Y )  { x=X; y=Y;}

    CPoinf& operator -= ( const CPoinf& a )  { x-=a.x; y-=a.y; return *this;}
    CPoinf& operator += ( const CPoinf& a )  { x+=a.x; y+=a.y; return *this;}
    CPoinf& operator *= (       float   s )  { x*=s;   y*=s;   return *this;}

    CPoinf  operator -  ( const CPoinf& a )  { return CPoinf(x-a.x, y-a.y);}
    CPoinf  operator +  ( const CPoinf& a )  { return CPoinf(x+a.x, y+a.y);}


    // Convert to Polar coordinates
    void    ToPolar()  {
        float R = sqrtf( x*x + y*y );
        a = atan2f( y,x );
        r = R;
    }

};


//////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_POINF_H__21C2BCBF_50B3_450F_9F40_514E7AA0BC7F__INCLUDED_)
