// Spacer.h: interface for the CSpacer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPACER_H__A6533EAC_4308_4E3F_8224_9BBC10B1B7CF__INCLUDED_)
#define      AFX_SPACER_H__A6533EAC_4308_4E3F_8224_9BBC10B1B7CF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////

#include "Poinf.h"


// Converts FLOAT-Space to Window-Space

class CSpacer
{

    CPoinf      m_pfOrigin;         // Origin
    float       m_fScale;           // Scale

    CPoint      m_ptOffset;         // Offset - Always Center Screen

    BYTE        m_bVerticalFlip;    // For ExportBmp


protected:

    // Attributes
    void        Restore();
    void        SetOffset( const CPoint& pt )   {  m_ptOffset = pt; }
    void        SetScale ( float f )            {  m_fScale = f; }
    void        SetVerticalFlip( BYTE b )       {  m_bVerticalFlip = b; }

    CPoinf      GetOrigin()  {  return m_pfOrigin; }
    float       GetScale()   {  return m_fScale;   }


    // Converters
    CPoinf      ToPoinf( CPoint );
    CPoint      ToPoint( CPoinf );


    // Operations
    void        MoveOrigin( const CPoint&, BYTE bButtonDown );
    void        Scale     ( CPoinf, float d );

    void        SetViewAsDefault( CPoinf* pf, int n );

public:
    
	CSpacer();

    void        Serialize( CArchive& );

};


//////////////////////////////////////////////////////////////////////

#endif // !defined(AFX_SPACER_H__A6533EAC_4308_4E3F_8224_9BBC10B1B7CF__INCLUDED_)
