// Vectal4View.h : interface of the CVectal4View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VECTAL4VIEW_H__1AE03B2D_2FF0_493C_ABBA_12774A36204F__INCLUDED_)
#define      AFX_VECTAL4VIEW_H__1AE03B2D_2FF0_493C_ABBA_12774A36204F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "MainFrm.h"
#include "Draw.h"


/////////////////////////////////////////////////////////////////////////////



class CVectal4View : public CView,
                     private CDraw
{
    BYTE    m_bInitOnce;    // Set Links, Slider Ranges etc
    BYTE    m_bOpened4;     // Opened File is 4 Version with saved Iteration, Modes etc

    
protected: // create from serialization only
	CVectal4View();
	DECLARE_DYNCREATE(CVectal4View)

// Attributes
public:
	CVectal4Doc* GetDocument();

// Operations
private:

    // Menu
    void    CheckMenuItem( UINT nID, BYTE bCheck ) {  
                CMainFrame* pFrm = (CMainFrame*)GetOwner();
                pFrm->GetMenu()->CheckMenuItem( nID, bCheck ? MF_CHECKED : MF_UNCHECKED );
                pFrm->GetToolBar()->GetToolBarCtrl().CheckButton( nID, bCheck );
            }

    // StatusBar
    void    ChangeCursorStatus();
                    
    

public:
    
    void    Serialize( CArchive& );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVectal4View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CVectal4View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CVectal4View)
	afx_msg void OnSize( UINT nType, int cx, int cy );
	afx_msg void OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
	afx_msg void OnFileExport();
	//}}AFX_MSG
    afx_msg void OnViewDefaultView( UINT );
    afx_msg void OnViewChangeModes( UINT );
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in Vectal4View.cpp
inline CVectal4Doc* CVectal4View::GetDocument()
   { return (CVectal4Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VECTAL4VIEW_H__1AE03B2D_2FF0_493C_ABBA_12774A36204F__INCLUDED_)
